#define NOFOOTER
#include "testlib.h"
#include <vector>

const int nmax = 2001;

using std::vector;

int n;
int T[nmax], V[nmax];
int d[nmax][nmax];
double total[nmax];
vector < int > e[nmax];

extern "C" void * memset ( void *, int, size_t );

void dfs ( int i, int * D, int prev = -1 )
{
    for ( int k, j = 0; j < (int)e[i].size(); ++j )
        if ( ( k = e[i][j] ) != prev )
        {
            D[k] = D[i] + ::d[i][k];
            dfs ( k, D, i );
        }
}

inline double Time ( int i, int j )
{
    return T[i] + d[i][j] / (double)V[i];
}

const double eps = 1e-4;

int main ( int argc, char ** argv )
{
    registerTestlibCmd ( argc, argv );

    double lA = ans.readDouble();
    double lC = ouf.readDouble();
    if ( !( lC + eps > lA ) )
        quit ( _wa, "wrong maximal time" );

    n = inf.readInt (1, nmax );
    for ( int i = 0; i < n; ++i )
    {
        T[i] = inf.readInt ( 0, 100 );
        V[i] = inf.readInt ( 1, 100 );
    }

    memset ( d, -1, sizeof ( d ) );
    for ( int i = 0; i < n; ++i )
        d[i][i] = 0;

    for ( int i = 0; i < n - 1; ++i )
    {
        int A = inf.readInt ( 1, n ) - 1;
        int B = inf.readInt ( 1, n ) - 1;
        int S = inf.readInt ( 1, 10000 );
        if ( d[A][B] != -1 ) quit ( _fail, "Given tree contains multiple edges or loops" );
        d[A][B] = d[B][A] = S;
        e[A].push_back ( B );
        e[B].push_back ( A );
    }

    for ( int i = 0; i < n; ++i )
        dfs ( i, d[i] );

    for ( int i = 0; i < n; ++i )
        total[i] = ans.readDouble();

    double lP = 0;
    int u = ouf.readInt ( 1, n );
    int U = u;
    while ( u != 1 )
    {
        int v = ouf.readInt ( 1, n );
        lP += Time ( u - 1, v - 1 );
        u = v;
    }

    if ( lP + eps < total[U - 1] ) quit ( _fail, "jury times is wrong" );
    if ( fabs ( total[U - 1] - lP ) > eps ) quit ( _wa, "Printed path isn`t minimal" );

    if ( fabs ( lP - lA ) < eps && fabs ( lP - lC ) < eps && fabs ( lA - lC ) < eps )
        quitf ( _ok, "N = %d", n );

    if ( lA + eps <= lP ) quit ( _fail, "contestant has better solution than jury" );
    quit ( _wa, "" );
}
